-- name: [CS] Beat
-- description: "He's a Sweet Soul Brother" Adds Beat from the Dreamcast Classic: Jet Set Radio!'

local E_MODEL_BEAT = smlua_model_util_get_id("beat_geo")
local TEX_BEAT = get_texture_info("icon-beat")

local TEXT_MOD_NAME = "Beat"

local VOICETABLE_BEAT = {
    [CHAR_SOUND_ATTACKED] = 'BeatOugh.mp3',
	[CHAR_SOUND_EEUH] = 'BeatGetUp.mp3',
	[CHAR_SOUND_LETS_A_GO] = 'BeatHaha.mp3',
    [CHAR_SOUND_DROWNING] = 'BeatFire.mp3',
    [CHAR_SOUND_DYING] = 'BeatDeath.mp3',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'BeatJump1.mp3',
    [CHAR_SOUND_HAHA] = 'BeatHaha.mp3',
    [CHAR_SOUND_HAHA_2] = 'BeatYeah.mp3',
	[CHAR_SOUND_DOH] = 'BeatDoh.mp3',
    [CHAR_SOUND_HERE_WE_GO] = 'BeatHaha.mp3',
    [CHAR_SOUND_HOOHOO] = 'BeatJump2.mp3',
    [CHAR_SOUND_MAMA_MIA] = 'BeatMama.mp3',
    [CHAR_SOUND_OKEY_DOKEY] = 'BeatYeah.mp3',
    [CHAR_SOUND_ON_FIRE] = 'BeatFire.mp3',
    [CHAR_SOUND_OOOF] = 'BeatHurt.mp3',
    [CHAR_SOUND_OOOF2] = 'BeatHurt.mp3',
	[CHAR_SOUND_HRMM] = 'BeatDoh.mp3',
    [CHAR_SOUND_PUNCH_HOO] = 'BeatJump2.mp3',
    [CHAR_SOUND_PUNCH_WAH] = 'BeatJump3.mp3',
    [CHAR_SOUND_PUNCH_YAH] = 'BeatPunch.mp3',
	[CHAR_SOUND_UH] = 'BeatGetUp.mp3',
    [CHAR_SOUND_UH2] = 'BeatGetUp.mp3',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'BowserByeBye.mp3',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'BeatHaha.mp3',
    [CHAR_SOUND_WAAAOOOW] ='BeatFall.mp3',
    [CHAR_SOUND_WAH2] = 'BeatJump3.mp3',
    [CHAR_SOUND_WHOA] = 'BeatWhoa.mp3',
    [CHAR_SOUND_YAHOO] = 'BeatYahoo.mp3',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'BeatYahoo.mp3', 'BeatYeah.mp3', 'BeatNice.mp3'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'BeatJump1.mp3', 'BeatJump3.mp3', 'BeatJump2.mp3'},
}

local PALETTE_BEAT = {
    [PANTS]  = "331000",
    [SHIRT]  = "604A76",
    [GLOVES] = "333333",
    [SHOES]  = "4F3C0D",
    [HAIR]   = "DFA32E",
    [SKIN]   = "F7A986",
    [CAP]    = "5B1B00",
}

if _G.charSelectExists then
    _G.charSelect.character_add("Beat", {"Yahoo!", "Beat's a Rudie from Tokyo-To who's part of the GGs!", "A Sweet Soul Brother if you will!", }, "Eschersimp Model,SabakiSabaku Lua and Voices", {r = 24, g = 208, b = 14}, E_MODEL_BEAT, CT_MARIO, TEX_BEAT)

	_G.charSelect.character_add_voice(E_MODEL_BEAT, VOICETABLE_BEAT)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_BEAT then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_BEAT then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end
_G.charSelect.character_add_palette_preset(E_MODEL_BEAT, PALETTE_BEAT)
